#include <iostream>  
using namespace std;

const int thresh = 15;

int custom_abs(int x, int bound)
{ // first the number we want the abs value of.
	// clip size, anything 0 <= x < bound -> 0 
	if (x <= 0)
		return -x;
	if (x >= bound)
		return x;
	return 0;
}


int rec_fxn()
{ // No local vars, no parameters, but endless recursion
	rec_fxn();
}


int main()  
{
	int v;
	cout << "Give me a number: " << endl;
	cin >> v;

	/* Look at how their addresses differ; that's because the global variable is in
	 * data segement; not so for v, as it is allocated on the stack (bottom of memory) */
	cout << "v is stored at = " << &v << endl;
	cout << "thresh is stored at = " << &thresh << endl;

	/* This causes a seg fault, because the stack keeps track of "calling" information,
	 * so it knows where to return to. The finite recursion consumes all the stack space. */
	//rec_fxn();

	int f = custom_abs(v, thresh);
	cout << "f = " << f << endl;		

	return 0;
}




